<?php

function MoneyStats($cid)
{
	global $modules_defaults;
	$fromwhere = "FROM money WHERE money != 0 AND campaign_id = $cid";
	$query = "
	(SELECT IF(money > 0,'Got','Spend') AS Type, ABS(SUM(money)) AS Money $fromwhere GROUP BY Type)
	UNION
	(SELECT IF(item_id = 0,'Found','Sold') AS Type, SUM(money) AS Money $fromwhere AND money > 0 GROUP BY Type)
	";
	CreateTableA(array('data' => $query, 'width' => '100%', 'title' => 'Money Stats'));

	echo "<center><a href='graph.php$modules_defaults[defaultlink]&gtype=money&mod_use_galview=1&cstats=$cid&big=1'><img border=0 src='graph.php$modules_defaults[defaultlink]&gtype=money&mod_use_galview=1&cstats=$cid'></a></center>";
}

function XPStats($cid)
{
	global $modules_defaults;
	echo "<center><a href='graph.php$modules_defaults[defaultlink]&gtype=xp&mod_use_galview=1&cstats=$cid&big=1'><img border=0 src='graph.php$modules_defaults[defaultlink]&gtype=xp&mod_use_galview=1&cstats=$cid'></a></center>";
}

function ItemStats($cid, $supposed = false)
{
	global $campaign, $modules_defaults, $subindex;
	$select = "COUNT(*) AS Amount, SUM(value * amount) AS Value, SUM(IF(bonus=0,value*amount,0)) AS Regular";
	$fromwhere = "FROM items WHERE campaign_id = $cid AND deleted = 0";

	$query = "
		(
			SELECT
				'All' AS Type,
				$select
			$fromwhere
		) UNION (
			SELECT
				CASE sold WHEN 0 THEN 'Present' WHEN 1 THEN 'Sold' WHEN 2 THEN 'Used' End AS Type,
				$select
			$fromwhere
			GROUP BY sold
		) UNION (
			SELECT
				IF (bought=1,'Bought','Found') AS Type,
				$select
			$fromwhere
			GROUP BY bought

		)
	";
	CreateTableA(array('data' => $query, 'width' => '100%', 'title' => 'Item Stats'));

	echo '<br>';
	$query = "SELECT
			players.name AS Player,
			IFNULL(SUM(amount*value), 0) AS Value,
			IFNULL(SUM(IF(bonus=0,amount*value,0)),0) AS Regular
	FROM
		(
			(SELECT -1 AS id, 'All' AS name) UNION
			(SELECT 0 AS id, 'Group' AS name) UNION
			(SELECT players.id, players.name FROM players WHERE campaign_id = $cid)
		) AS players
	LEFT JOIN
		items ON (player_id = players.id OR players.id = -1) AND items.sold = 0 AND items.deleted = 0 AND items.campaign_id = $cid
	WHERE
		Value != 0
	GROUP
		BY players.id
	";

	CreateTableA(array('data' => $query, 'width' => '100%', 'title' => 'Player stats'));

	if ($supposed)
	{
		$query = "SELECT IFNULL(SUM(xp), 0) FROM xp WHERE campaign_id = $cid";
		$xp = mysql_result(mod_mysql_querya($query), 0);

		$xp = round(sqrt(0.25 + $xp / 1000 * 2) + 0.5, 2);

		$query = "SELECT num as xp, startmoney as money FROM d_startmoney WHERE num < $xp AND dataset_id = $campaign[dataset_id] ORDER BY startmoney DESC LIMIT 1";
		$result = mod_mysql_querya($query);
		if (mysql_num_rows($result))
		{
			$rel1 = mysql_fetch_assoc($result);
		}
		else
		{
			$rel1 = array('money' => 0, 'xp' => 0);
		}

		$query = "SELECT num as xp, startmoney as money FROM d_startmoney WHERE num >= $xp AND dataset_id = $campaign[dataset_id] ORDER BY startmoney ASC LIMIT 1";
		$result = mod_mysql_querya($query);
		if (mysql_num_rows($result))
		{
			$rel2 = mysql_fetch_assoc($result);
		}
		else
		{
			$rel2 = array('money' => $rel1['money'], 'xp' => $xp);
		}

		if ($xp == 0)
		{
			$moneyshould = '-';
		}
		else if ($xp == $rel2['xp'])
		{
			$moneyshould = $rel2['money'];
		}
		else
		{
			$moneyshould = round($rel1['money'] + ($rel2['money'] - $rel1['money']) / ($rel2['xp'] - $rel1['xp']) * ($xp - $rel1['xp']), 0);
		}
		echo "Start Money for Char Level: $moneyshould";
	}

	echo "<br><br><a name='itemstats'></a>";
	if ($subindex === 'stats' || isset($_REQUEST['cstats']) || isset($_REQUEST['itemstats']))
	{
		$query = "SELECT * FROM players WHERE campaign_id = $cid AND deleted = 0";
		$players = array_merge(array(-1 => array('id' => 0, 'name' => 'Group')), mod_Query2Array($query, false, false));
		foreach ($players as $index => $player)
		{
			$query = "SELECT COUNT(*) FROM possession WHERE player_id = $player[id]";
			if (mysql_result(mod_mysql_querya($query), 0) == 0)
			{
				$query = "SELECT COUNT(*) FROM items WHERE player_id = $player[id]";
				if (mysql_result(mod_mysql_querya($query), 0) == 0)
				{
					unset($players[$index]);
				}
			}
		}

		$scriptlink = AddSlashes("graph.php$modules_defaults[defaultlink]&gtype=items&mod_use_galview=1&cstats=$cid");

		echo <<<EOT

<script>
function ReloadItemImage()
{
	chkboxes = document.getElementsByName('playerchkbox');
	validplayers = [];
	for (i = 0;i < chkboxes.length;i++)
	{
		if (chkboxes[i].checked)
		{
			newval = chkboxes[i].getAttribute('playerid');
			validplayers[validplayers.length] = newval;
		}
	}
	link = '$scriptlink' + '&validplayers=' + validplayers.join(',');
	document.getElementsByName('imgitemstats')[0].src = link;
}
</script>

EOT;

		echo "<table width=100% cellpadding=0 cellspacing=0><tr><td valign=top>" . mod_linkToForm($modules_defaults['defaultlink']);
		$showplayers = array();
		foreach ($players as $index => $player)
		{
			echo "<input type=checkbox name='playerchkbox' playerid='$player[id]' " . (($showplayer = (!isset($_REQUEST['selplayerstats']) || isset($_REQUEST["player$player[id]"]))) ? 'checked' : '') . "> $player[name]<br>";
		}
		echo "<input type=button onClick='ReloadItemImage()' value=Reload></form>";

		echo '</td><td width=1>';
		echo "<center><a href='JavaScript:document.location.href=document.getElementsByName(\"imgitemstats\")[0].src + \"&big=1\";'><img name='imgitemstats' border=0 src='graph.php$modules_defaults[defaultlink]&gtype=items&mod_use_galview=1&cstats=$cid'></a></center>";
		echo '</td></tr></table>';
	}
	else
	{
		echo "<a href='$modules_defaults[defaultlink]&itemstats=1#itemstats'>Show Item Stats</a>";
	}
}

$storyoptions = array(0 => 'Inactive', 1 => 'Touched', 2 => 'Done', 3 => 'Failed', 4 => 'Obsolete');

function StoryStats($cid, $full = true)
{
	global $storyoptions, $modules_defaults;
	$wherepart = $full ? '' : 'AND state != 0';
	$query = "SELECT COUNT(id) AS count, state FROM story WHERE campaign_id = $cid $wherepart GROUP BY state ORDER BY state ASC";
	$result = mod_mysql_querya($query);
	$table = array();
	$fullcount = 0;
	while ($tmp = mysql_fetch_assoc($result))
	{
		$table[] = array('State' => $storyoptions[$tmp['state']], 'Count' => $tmp['count']);
		$fullcount += $tmp['count'];
	}
	$table[] = array('State' => 'All', 'Count' => $fullcount);
	CreateTableA(array('data' => $table, 'width' => '100%', 'title' => 'Story Stats'));

	echo "<center><a href='graph.php$modules_defaults[defaultlink]&gtype=story&mod_use_galview=1&cstats=$cid&big=1'><img border=0 src='graph.php$modules_defaults[defaultlink]&gtype=story&mod_use_galview=1&cstats=$cid'></a></center>";
}

function ShowStory($id, $name)
{
	global $storyoptions, $modules_defaults, $story, $storylock;
	$query = "SELECT text, state FROM story WHERE id = $id";
	$result = mysql_fetch_assoc(mod_mysql_querya($query));

	if (!$storylock && isset($_GET['hidedone']) && $_GET['hidedone'])
	{
		if ($storyoptions[$result['state']] == 'Done' || $storyoptions[$result['state']] == 'Failed' || $storyoptions[$result['state']] == 'Obsolete')
		{
			$query = "SELECT COUNT(*) FROM story WHERE root = $id AND state NOT IN (2, 3, 4)";
			if (mysql_result(mod_mysql_querya($query), 0) == 0) return(false);
		}
	}

	$text = "<select onClick='if(this.value!=$result[state]){document.location.href=\"$modules_defaults[defaultlink]$story->addlink&setstate=$id&state=\" + this.value + \"#story$id\";}'>" . mod_createselectoptionsarray($storyoptions, $result['state']) . "</select>";

	$fullids = $ids = array($id);
	do
	{
		$query = "SELECT id FROM story WHERE root IN (" . implode(',', $ids) . ")";
		$ids = mod_Query2Array($query, false, 0);
		$fullids += $ids;
	} while (count($ids));

	$states = array();
	if (count($fullids))
	{
		$query = "SELECT state FROM story WHERE id IN (" . implode(',', $fullids) . ") GROUP BY state";
		$result2 = mod_mysql_querya($query);
		while ($tmp = mysql_fetch_assoc($result2))
		{
			$states[] = $storyoptions[$tmp['state']];
		}
	}

	$symbols = $symbol = array();
	if ($storyoptions[$result['state']] == 'Failed') $symbols[] = 'failed';
	else if ($storyoptions[$result['state']] == 'Touched') $symbols[] = 'touched';
	else if ($storyoptions[$result['state']] == 'Done')
	{
		if (in_array('Failed', $states)) $symbols[] = 'done2';
		else $symbols[] = 'done';
	}

	if (in_array('Inactive', $states)) $symbols = array_merge(array('inactive'), $symbols);

	foreach ($symbols as $sym)
	{
		$symbol[] = "<img src='img/$sym.gif'>";
	}
	$symbol = implode('&nbsp', $symbol);

	if ($storyoptions[$result['state']] == 'Touched') $symbol .= '<br>(' . implode(', ', $states) . ')';

	$retVal = array('Name' => '<a name="story' . $id . '"></a><table cellpadding=0 cellspacing=0 width=100%><tr><td valign=top>' . $name . '</td><td align=right valign=top>' . $symbol . '</td></tr></table>', 'Text' => mod_cr2br($result['text']));
	if (!$storylock) $retVal['State'] = $text;

	return($retVal);
}

function GenXpText($cid)
{
	$query = "SELECT SUM(xp) FROM xp WHERE campaign_id = $cid";
	$xp = mysql_result(mod_mysql_querya($query), 0);
	$query = "SELECT SUM(xp) FROM xp WHERE campaign_id = $cid AND xp > 0";
	$fullxp = mysql_result(mod_mysql_querya($query), 0);
	$xp = "XP: $xp (Lvl: " . round(sqrt(0.25 + $xp / 1000 * 2) + 0.5, 2) . "), (Gained: $fullxp (Lvl:" . round(sqrt(0.25 + $fullxp / 1000 * 2) + 0.5, 2) . "), Lossed:" . ($fullxp - $xp) . ')<br>';
	return($xp);
}

function DoStory($cid, $lock = true)
{
	global $modules_defaults, $userdata, $storyoptions, $story, $storylock;

	$edit = new sqledit;
	$edit->sqltablename = 'story';
	$edit->adddefaults['campaign_id'] = $cid;
	$edit->sqlwhere = '';
	$edit->relations = array(
		'name' => array('name' => 'Name', 'force' => true, 'link' => $modules_defaults['defaultlink'] . '&setsroot=[ID]'),
		'root' => array('name' => 'Root', 'type' => 'root', 'rootdefaults' => true, 'hide' => true),
		'text' => array('name' => 'Text', 'cur' => 40, 'rows' => 4)
	);
	$edit->title = "Storyline";

	if (isset($_GET['setstate']) && isset($_GET['state']))
	{
		$query = "SELECT user_id FROM story LEFT JOIN campaigns ON campaign_id = campaigns.id WHERE story.id = " . intval($_GET['setstate']);
		if (mysql_result(mod_mysql_querya($query), 0) == $userdata['id'])
		{
			$query = "UPDATE story SET state = " . intval($_GET['state']) . ", state_timestamp = " . ($_GET['state'] > 1 ? time() : 0) . " WHERE id = " . intval($_GET['setstate']);
			mod_mysql_querya($query);
		}
	}

	mod_addDefaultLink(array('hidedone', 'mod_diropened0'));

	if (!$lock)
	{
		$hidedone = new selectparam;
		$hidedone->name = 'hidedone';
		$hidedone->type = 'checkbox';
		echo CreateSelectParam($hidedone), ' hide old entries';
	}

	$story = new displaydirectory;
	$story->callback_function = 'ShowStory';
	$story->table = 'story';
	$story->sqlwhere = "campaign_id = $cid";
	$story->tabledata['title'] = 'Storyline';
	if (!$lock)
		$story->edit = $edit;
	$story->expandall = $lock;
	$story->rootname = 'Story';
	$story->changeroot = array();
	$storylock = $lock;
	CreateDirectory($story);
}

function DoStats($cid, $admin = false)
{
	$query = "SELECT * FROM campaigns WHERE id = $cid";
	$campaign = mysql_fetch_assoc(mod_mysql_querya($query));

	echo "XP Stats:<br>";
	XPStats($cid);
	echo GenXpText($cid);
	echo '<br><hr><br>';
	$query = "SELECT SUM(money) FROM money WHERE campaign_id = $cid";
	echo 'Money: ', mysql_result(mod_mysql_querya($query), 0), '<br><br>';
	MoneyStats($cid);
	echo '<br><hr><br>';
	ItemStats($cid);

	$typepart = 'CASE `items`.`type` WHEN "4" THEN "Amulet" WHEN "1" THEN "Armor" WHEN "11" THEN "Arrows" WHEN "7" THEN "Belt" WHEN "6" THEN "Boots" WHEN "12" THEN "Bracers" WHEN "5" THEN "Cloak" WHEN "14" THEN "Equipment" WHEN "8" THEN "Gloves" WHEN "9" THEN "Helmet" WHEN "16" THEN "Potion" WHEN "3" THEN "Ring" WHEN "15" THEN "Scroll" WHEN "2" THEN "Shield" WHEN "-1" THEN "Special" WHEN "10" THEN "Treasure" WHEN "13" THEN "Vestment" WHEN "0" THEN "Weapon" ELSE "-" END AS `Type`';

	$query = "SELECT items.name AS Item, $typepart, SUM(items.amount) AS Amount, SUM(items.amount * items.value) AS Value, CASE sold WHEN 1 THEN 'sold' WHEN 2 THEN 'used' ELSE '-' END AS Sold FROM items LEFT JOIN players ON player_id = players.id WHERE items.campaign_id = $cid AND items.deleted = 0 GROUP BY items.name, items.type, items.sold ORDER BY items.name ASC";
	CreateTableA(array('data' => $query, 'width' => '100%', 'title' => 'Item List'));

	if ($campaign['stats'] == 2 || $admin)
	{
		$query = "SELECT item_list.name AS Item, players.name AS Player, REPLACE(descr,'\\n','<br>') AS Description, done AS 'Item Used' FROM item_list LEFT JOIN players ON player_id = players.id WHERE item_list.campaign_id = $cid";
		CreateTableA(array('data' => $query, 'width' => '100%', 'title' => 'Special Item list', 'inTd' => 'valign=top'));
	}

	echo '<br><hr><br>';
	StoryStats($cid, $campaign['stats'] == 2 || $admin);
	if ($campaign['stats'] == 2 || $admin)
	{
		echo '<br><hr><br>';
		DoStory($cid);
	}
}

?>