<?php

require 'include.php';

$attributes = array('str' => 'Strength', 'dex' => 'Dexterity', 'con' => 'Constitution', 'int' => 'Intelligence', 'wis' => 'Wisdom', 'cha' => 'Charisma');
$attr_order = array('str', 'dex', 'con', 'int', 'wis', 'cha');

if (!is_callable('do_char_data'))
{
	function do_char_data(&$char, $primary, $data, $ref, $name)
	{
		foreach ($char[$primary] as $index => $value)
		{
			$query = "SELECT * FROM `" . mysql_escape_string($data) . "` WHERE id = $value[$ref]";
			$char[$primary][$index][$name] = mysql_fetch_assoc(mod_mysql_querya($query));
		}
	}

	function adeptName($name)
	{
		if (is_array($name))
		{
			foreach($name as $refName)
			{
				$refName = adeptName($refName);
			}
			return($name);
		}
		if (strlen($name) == 0) return('');
		$j = 0;
		$retVal = $name{0};
		for ($i = 1;$i < strlen($name);$i++)
		{
			if ($name{$i} >= 'A' && $name{$i} <= 'Z' && $name{$i - 1} >= 'a' && $name{$i - 1} <= 'z')
			{
				$retVal .= ' ';
			}
			$retVal .= $name{$i};
		}
		return($retVal);
	}

	global $txt_pre;
	$txt_pre .= <<<EOT

<style>

.c_caption
{
	color:red;
	font-weight:normal;
}

.c_important
{
	color:green;
	font-weight:bold;
}

.c_unimportant
{
	color:blue;
	font-weight:normal;
}

.c_include
{
	color:orange;
}

.c_noshield
{
	color:brown;
}

.c_left
{
	//border-left:1px solid black;
}

.c_right
{
	border-right:1px solid black;
}

.c_top
{
	//border-top:1px solid black;
}

.c_bottom
{
	border-bottom:1px solid black;
}

.c_table
{
	//border:1px solid black;
	border-top:1px solid black;
	border-left:1px solid black;
}

</style>

EOT;
}

if (!isset($userdata)) die();

$query = "SELECT
		characters.*,
		d_races.name AS race,
		IF(d_subraces.id IS NULL,'',d_subraces.name) AS subrace,
		d_schools.name AS specializedschool
	FROM
		characters
	LEFT JOIN d_races ON characters.race_id = d_races.id
	LEFT JOIN d_races AS d_subraces ON d_races.subrace = d_subraces.id
	LEFT JOIN d_schools ON characters.specialized = d_schools.id
	WHERE
		characters.id = $id
	";
$char = mysql_fetch_assoc(mod_mysql_querya($query));

$query = "SELECT d_races.*, d_size.name AS size_name FROM d_races LEFT JOIN d_size ON d_size.id = 5 + d_races.size WHERE d_races.id = $char[race_id]";
$char['d_race'] = mysql_fetch_assoc(mod_mysql_querya($query));

$query = "SELECT
		char_classes.*,
		d_characters.name AS class
	FROM
		char_classes
	LEFT JOIN d_characters ON class_id = d_characters.id
	WHERE
		character_id = $id
	ORDER BY
		sort ASC";
$char['classes'] = mod_Query2Array($query);

foreach ($attributes as $index => $value)
{
	$char[$index . '_mod'] = floor(($char[$index] - 10) / 2);
}

do_char_data($char, 'classes', 'd_characters', 'class_id', 'd_class');

foreach ($char['classes'] as $index => $class)
{
	$query = "SELECT type, col, text, row FROM char_spellsknown WHERE class_id = $class[id]";
	$result = mod_mysql_querya($query);
	while ($tmp = mysql_fetch_assoc($result))
	{
		$char['classes'][$index][$spelltype = ($tmp['type'] == 'spell' ? ($tmp['row'] ? 'spells_day' : 'spells_known') : 'powers')][$tmp['col']] = $tmp['text'];
	}

	if (!isset($spelltype)) continue;

	$spelldb = ($spelltype == 'powers' ? 'd_powers' : 'd_spells');
	$query = "SELECT char_spells.*, $spelldb.name from char_spells LEFT JOIN $spelldb ON $spelldb.id = spell_id WHERE class_id = $class[id]";
	$result = mod_mysql_querya($query);
	while ($tmp = mysql_fetch_assoc($result))
	{
		$query = "SELECT * FROM $spelldb WHERE id = $tmp[spell_id]";
		$tmp['d_spell'] = mysql_fetch_assoc(mod_mysql_querya($query));
		$char['classes'][$index]['spells'][$tmp['level']][$tmp['sort']] = $tmp;
	}
	unset($spelltype);
}

$query = "SELECT d_domains.name FROM char_domains LEFT JOIN d_domains ON char_domains.domain_id = d_domains.id WHERE character_id = $id ORDER BY sort ASC";
$char['domains'] = mod_Query2Array($query, false, 0);

$query = "SELECT d_schools.name FROM char_forbidden LEFT JOIN d_schools ON school_id = d_schools.id WHERE character_id = $id ORDER BY sort ASC";
$char['forbidden'] = mod_Query2Array($query, false, 0);

$query = "SELECT char_feats.*, d_feats.name AS feat FROM char_feats LEFT JOIN d_feats ON char_feats.feat_id = d_feats.id WHERE character_id = $id ORDER BY done ASC, sort ASC";
$char['feats'] = mod_Query2Array($query, false);
do_char_data($char, 'feats', 'd_feats', 'feat_id', 'd_feat');
$char['feat_count'] = count($char['feats']);
foreach ($char['feats'] as &$ref_feat)
{
	switch ($ref = intval($ref_feat['reference_id']))
	{
		case 0:
			$ref_feat['reference'] = '';
			break;
		case -1:
			$ref_feat['reference'] = 'All';
			break;
		default:
			switch ($ref_feat['d_feat']['dep'])
			{
				case 1:
					$query = "SELECT d_equipment.name FROM d_weapons LEFT JOIN d_equipment ON d_weapons.name = d_equipment.id WHERE d_weapons.id = $ref";
					break;
				case 2:
					$query = "SELECT name FROM d_schools WHERE id = $ref";
					break;
				case 3:
					$query = "SELECT name FROM d_skills WHERE id = $ref";
					break;
				default:
					trigger_error('No Dependancy', E_USER_ERROR);
					break;
			}
			$ref_feat['reference'] = ($query === false ? '' : mysql_result(mod_mysql_querya($query), 0));		
			break;
	}
}

$query = "SELECT char_skills.*, d_skills.name AS skill FROM char_skills LEFT JOIN d_skills ON skill_id = d_skills.id WHERE character_id = $id ORDER BY sort ASC";
$char['skills'] = mod_Query2Array($query);
do_char_data($char, 'skills', 'd_skills', 'skill_id', 'd_skill');
$char['skill_count'] = count($char['skills']);
foreach ($char['skills'] as &$ref_skill)
{
	$ref_skill['attr'] = $char[$attr_order[$ref_skill['d_skill']['attr']] . '_mod'];
	$ref_skill['level'] = floor(mod_array_sum($ref_skill, array('rank', 'bonus', 'attr')) - $ref_skill['malus']);
}

$query = "SELECT char_equipment.*, d_equipment.name FROM char_equipment LEFT JOIN d_equipment ON equip_id = d_equipment.id WHERE character_id = $id ORDER BY treasure ASC, sort ASC";
$char['equipment'] = mod_Query2Array($query);
$query = "SELECT COUNT(*) FROM char_equipment WHERE character_id = $id AND treasure = 0";
$char['equip_count'] = mysql_result(mod_mysql_querya($query), 0);
do_char_data($char, 'equipment', 'd_equipment', 'equip_id', 'd_equip');
foreach ($char['equipment'] as &$ref_equip)
{
	$query = "SELECT char_equipeffects.*, d_effects.effect AS effect FROM char_equipeffects LEFT JOIN d_effects ON effect_id = d_effects.id WHERE equip_id = $ref_equip[id] ORDER BY sort ASC";
	$ref_equip['effects'] = mod_Query2Array($query);
	do_char_data($ref_equip, 'effects', 'd_effects', 'effect_id', 'd_effect');
}

$query = "SELECT * FROM char_monsterattack WHERE character_id = $id ORDER BY sort ASC";
$char['monsterattack'] = mod_Query2Array($query, false, false);

$char['ac'] = 10 + mod_array_sum($char, array('ac_armor', 'ac_shield', 'ac_dex', 'ac_rest', 'ba_size'));
$char['ba_melee'] = $char['ba'] + $char['ba_size'] + $char['ba_melee_attr'] + $char['ba_melee_rest'];
$char['ba_range'] = $char['ba'] + $char['ba_size'] + $char['ba_range_attr'] + $char['ba_range_rest'];
$char['st_ref'] = $char['st_ref_base'] + $char['st_ref_mage'] + $char['st_ref_rest'] + $char['st_ref_attr'];
$char['st_wil'] = $char['st_wil_base'] + $char['st_wil_mage'] + $char['st_wil_rest'] + $char['st_wil_attr'];
$char['st_fort'] = $char['st_fort_base'] + $char['st_fort_mage'] + $char['st_fort_rest'] + $char['st_fort_attr'];
$char['init'] = $char['init_rest'] + $char['init_dex'];

echo "
<table border=0 cellpadding=2 cellspacing=0 class='c_table' width=100%>
<tr>";

if ($char['monster_id'])
{
	$query = "SELECT d_monsters.*, d_size.name AS size, d_monstertypes.name AS monstertype FROM d_monsters LEFT JOIN d_size ON d_monsters.size = d_size.id LEFT JOIN d_monstertypes ON d_monsters.type = d_monstertypes.id WHERE d_monsters.id = $char[monster_id]";
	$char['d_monster'] = mysql_fetch_assoc(mod_mysql_querya($query));
	echo mod_col("Type", $char['d_monster']['monstertype'] . ' (' . $char['d_monster']['size'] . ')', true, false, true, 3);
}
else
{
	echo mod_col("Race", adeptName($char['race']) . ($char['subrace'] == '' ? '' : (" (" . adeptName($char['subrace']) . ")")). ' (' . adeptName($char['d_race']['size_name']) . ')', true, false, true, 3);
}

echo 	mod_col("HG", $char['monster_id'] && count($char['classes']) && ($char['classes'][0]['class_id'] || count($char['classes']) > 1) ? ("$char[cr] &nbsp; <font class='c_unimportant'>($char[mixed_cr] / " . ($char['cr'] - $char['mixed_cr']) . ')</font>') : $char['cr'], true, false, true, 3) .
	mod_col("Name", $char['name'], true, false, true, 3) .
"</tr>";

if ($char['monster_id'])
{
	$monsteronly = count($char['classes']) == 0 || $char['classes'][0]['class_id'] == 0 ? 'c_bottom' : '';
	echo mod_col('Monster', "<table width=100% cellpadding=0 cellspacing=0><tr><td align=left class='c_important'>" . str_replace(' ', '&nbsp;', adeptName($char['d_monster']['name'])) . "</td><td width='30%' style='padding-left:10;' class='c_caption'>(TW <font class='c_important'>$char[hd]</font>)</td></tr></table>", true, false, true, $monsteronly == '' ? 1 : 3);
	echo mod_ecols(4, array("c_left c_top $monsteronly", "c_right c_top $monsteronly"));
}


foreach ($char['classes'] as $index => $class)
{
	if ($class['class_id'] == 0) continue;

	$lastclass = ($index == count($char['classes']) - 1 || (isset($char['classes'][$index + 1]) && $char['classes'][$index + 1]['class_id'] == 0)) ? -1 : true;
	$lastclassadd = '';

	if ($lastclass === -1)
	{
		$lastclassadd .= ' c_bottom';
		if ($index == 0 && !$char['monster_id'])
		{
			$lastclass = 3;
			$lastclassadd .= ' c_top';
		}
	}
	else if ($index == 0 && !$char['monster_id'])
	{
		$lastclass = 1;
		$lastclassadd .= ' c_top';
	}

	echo "<tr>";
	echo mod_col("Class", "<table width=100% cellpadding=0 cellspacing=0><tr><td width=50% align=right class='c_important'>" . adeptName($class['class']) . "</td><td style='padding-left:10;' class='c_caption'>(Level <font class='c_important'>$class[levels]</font>)</td></tr></table>", true, false, true, $lastclass);
		if ($char['specializedschool'] != 'Allgemein' && $class['d_class']['specialize'] == 1)
		{
			echo mod_col("Specialized", adeptName($char['specializedschool']), true, false, true, $lastclass);
		}
		else if ($class['d_class']['domains'])
		{
			echo mod_col("Domains", implode(', ', adeptName($char['domains'])), true, false, true, $lastclass);
		}
		else
		{
			echo mod_ecols(2, array("c_left$lastclassadd" , "c_right$lastclassadd"));
		}

		if ($char['specializedschool'] != 'Allgemein' && $class['d_class']['specialize'])
		{
			echo mod_col("Forbidden", adeptName(implode(', ', $char['forbidden'])), true, false, true, $lastclass);
		}
		else
		{
			echo mod_ecols(2, array("c_left$lastclassadd", "c_right$lastclassadd"));
		}
	echo '</tr>';
}

$tmplines[0] = mod_col("Hitpoints", $char['hp'], true, false, true, 1);
$tmplines[0] .= mod_col("Base Attack", $char['ba'], true, false, true, 1);

$tmplines[2] = mod_col("Break SR", $char['sr_break'], true, false, true, 1);
$tmplines[2] .= mod_col("Speed", $char['speed'], true, false, true, 1);

$tmplines[4] = mod_col("SR", $char['sr'], true, false, true, 1);
$tmplines[4] .= mod_col("Attacks", $char['attacks1'], true, false, true, 1);

$i = 0;
foreach ($attributes as $index => $value)
{
	echo "<tr>" . mod_col($value, sprintf("%3d (%2d)", $char[$index], $char[$index . '_mod']), true, false, true, $index == 'str' ? 1 : ($index == 'cha' ? -1 : true)) . (isset($tmplines[$i++]) ? $tmplines[$i - 1] : mod_ecols(4, array('c_left c_bottom', 'c_right c_bottom'))) . '</tr>';
}

echo '<tr>' . mod_col('Attacks of Opportunity', $char['attacksopp'], true, false, true, 3) . mod_col('Armor Malus', $char['armor_malus'], true, false, true, 3) .
	mod_col('Initiative', "<font class='c_important'>$char[init]</font> = <font class='c_unimportant'>$char[init_rest] + $char[init_dex]</font> (<font class='c_caption'>Dex. Mod.</font>)", false, false, true, 3) . '</tr>';

if ($char['attacksmonk'])
{
	echo '<tr>' . mod_ecols(2, array('c_left c_top c_bottom', 'c_right c_top c_bottom')) . mod_col('Unarmed Damage', "$char[damagemonk1]W$char[damagemonk2]", true, false, true, 3) . mod_col('Unarmed Attacks', $char['attacksmonk'], true, false, true, 3) . '</tr>';
}

echo mod_cols(array('', 'Attack Bonus', array('= ', 'Base Attack'), array('+ ', 'Attribute Modifier'), array('+ ', 'Size Modifier'), array('+ ', 'Other Modifier')), true, true, false, false, -2, true);
echo mod_cols('Melee', 'c_caption', 1, false, false, -2, 1) . mod_cols(array($char['ba_melee'], $char['ba'], $char['ba_melee_attr'], $char['ba_size'], $char['ba_melee_rest']), 'c_unimportant', -1, false, false, -2, 1);
echo mod_cols('Ranged', 'c_caption', 1, false, false, -2, -1) . mod_cols(array($char['ba_range'], $char['ba'], $char['ba_range_attr'], $char['ba_size'], $char['ba_range_rest']), 'c_unimportant', -1, false, false, -2, -1);

echo mod_cols(array('', 'Saving Throw', array('= ', 'Base'), array('+ ', 'Attribute Modifier'), array('+ ', 'Mage Modifier'), array('+ ', 'Other Modifier')), true, true, false, false, -2, true);
echo mod_cols('Reflex Save', 'c_caption', 1, false, false, -2, 1) . mod_cols(array($char['st_ref'], $char['st_ref_base'], $char['st_ref_attr'], $char['st_ref_mage'], $char['st_ref_rest']), array(0 => 'c_important', -1 => 'c_unimportant'), -1, false, false, -2, 1);
echo mod_cols('Will Save', 'c_caption', 1) . mod_cols(array($char['st_wil'], $char['st_wil_base'], $char['st_wil_attr'], $char['st_wil_mage'], $char['st_wil_rest']), array(0 => 'c_important', -1 => 'c_unimportant'), -1, false, false, -2);
echo mod_cols('Fortitude Save', 'c_caption', 1, false, false, -2, -1) . mod_cols(array($char['st_fort'], $char['st_fort_base'], $char['st_fort_attr'], $char['st_fort_mage'], $char['st_fort_rest']), array(0 => 'c_important', -1 => 'c_unimportant'), -1, false, false, -2, -1);

echo mod_cols(array(array('', 'AC', ' = 10'), array('+ ', 'Armor'), array('+ ', 'Shield'), array('+ ', 'Dex. Mod.'), array('+ ', 'Size Mod.'), array('+ ', 'Other Mod.')), true, true, false, false, -2, true);
echo mod_cols(array($char['ac'], $char['ac_armor'], $char['ac_shield'], $char['ac_dex'], $char['ba_size'], $char['ac_rest']), array(0 => 'c_important', -1 => 'c_unimportant'), true, false, false, -2, true);

echo '<tr>' . mod_col('Feats', $char['feat_count'], 0, 5, true, 3) . '</tr>';
$pos = 0;
foreach ($char['feats'] as $index => $feat)
{
	echo mod_cols(array(adeptName($feat['feat']), adeptName($feat['reference'])), $feat['done'] ? 'c_important' : 'c_unimportant', $pos == 0 ? 1 : ($pos == 2 ? -1 : false), false, false, 2, $index < 3 ? ($index >= count($char['feats']) - count($char['feats']) % 3 - (count($char['feats']) % 3 == 0 ? 3 : 0) ? true : 1) : ($index >= count($char['feats']) - count($char['feats']) % 3 - (count($char['feats']) % 3 == 0 ? 3 : 0) ? -1 : 0));
	$pos = ($pos + 1) % 3;	
}
mod_fixpos(2 * $pos, 6, array('c_left c_bottom', 'c_right c_bottom'));

echo '<tr>' . mod_col('Skills', $char['skill_count'], 0, false, true, 3) . mod_col('Skill Points', $char['skillpoints'], 0, 3, true, 3) . '</tr>';

echo '<tr>';
$captions = '<td width="30">' . implode('</td><td width="30">', array('Lvl', 'Rnk', 'B', 'Attr', 'Malus')) . '</td>';
for ($i = 0;$i < 3;$i++)
{
	echo mod_cols(array('', "<table cellpadding=0 cellspacing=0 class='c_caption'><tr>$captions</tr></table>"), false, false, false, array(1 => 'align=center'), -2, 1);
}
echo '</tr>';

$pos = 0;
foreach ($char['skills'] as $index => $skill)
{
	echo mod_cols(array(adeptName($skill['skill']),
		'<table cellpadding=0 cellspacing=0>' . str_replace('<td', '<td width="30"', mod_cols(array($skill['level'], array('= ', $skill['rank']), array('+ ', $skill['bonus']), array('+ ', $skill['attr']), array('- ', $skill['malus'])), array(0 => 'c_important', -1 => 'c_unimportant'), true, false, false, 0)) . '</table>'
		), array('c_important'), $pos == 0 ? 1 : ($pos == 2 ? -1 : false), false, array(1 => 'align=center'), -2, $index >= count($char['skills']) - count($char['skills']) % 3 - (count($char['skills']) % 3 == 0 ? 3 : 0) ? -1 : 0);
	$pos = ($pos + 1) % 3;	
}
mod_fixpos(2 * $pos, 6, array('c_left c_right c_bottom'));

echo mod_col('Equipment' . (count($char['monsterattack']) ? ' / Monster Attacks' : ''), $char['equip_count'] . ' Items' . (count($char['monsterattack']) ? (' <font class="c_caption">/</font> ' . count($char['monsterattack']) . ' Attacks') : ''), 0, false, true, 3) . mod_col('Primary Attack', $char['attack1'] == 0 ? 'Fist' : ($char['attack1'] == 5 ? 'Natural' : $AttackOptions[$char['attack1']]), true, false, true, 3) . mod_col('Secondary Attack', $char['attack2'] == 0 ? '-' : $AttackOptions[$char['attack2']], true, false, true, 3);

if (count($char['monsterattack']))
{
	foreach ($char['monsterattack'] as $index => $monsterattack)
	{
		echo mod_cols(array($monsterattack['type'], $monsterattack['name'], "Damage:", $monsterattack['dmg1'] . 'W' . $monsterattack['dmg2'] . ' + ' . $monsterattack['dmg3'], 'Attack Bonus:', str_replace(':', ' <font class="c_caption">/</font> ', $monsterattack['attack'])),
			array(0 => 'c_unimportant', 2 => 'c_caption',  4 => 'c_caption', -1 => 'c_important'), true, false, false, true, $index == count($char['monsterattack']) - 1 ? -1 : 0
		);
	}
}

foreach ($char['equipment'] as $index => $equip)
{
	if ($equip['treasure'] && !isset($treasurestart))
	{
		$treasurestart = true;
		echo mod_cols(array('<hr color=red>', 'Treasure', '<hr color=red>'), 'c_caption', true, array(2, 2, 2), array('', 'align="center"'));
	}
	$money = $equip['value'] . ' <font class="' . ($equip['include'] ? 'c_include' : 'c_caption') . '">Gold</font>';
	if (($equip['equiptype'] >= 0 && $equip['equiptype'] <= 2) || $equip['equiptype'] == 11)
	{
		$enhence = "<table class='c_caption' width=100% cellpadding=0 cellspacing=0><tr><td>Enhenced: <font class='c_unimportant'>+$equip[enhence]</font></td><td>Effects: <font class='c_unimportant'>$equip[effect1] ($equip[effect2])</font></td></tr></table>";
		if ($equip['equiptype'] == 0)
		{
			$dmg = "Dmg: <font class='c_important'>" . mod_nbsp(sprintf("%dW%2d + %2d</font>", $equip['dmg1'], $equip['dmg2'], $equip['dmg3']));
			$critical = "Critical: <font class='c_important'>$equip[critical1]-20 / $equip[critical2]x</font>";
			$attack = "Attack: <font class='c_important'>$equip[attack]";
			if ($equip['d_equip']['attacktype'] == 2) $attack .= " / $equip[attack2]";
			$attack .= '</font>';
			if ($equip['max_str']) $dmg = "<table class='c_caption' width=100% cellpadding=0 cellspacing=0><tr><td width=50%>$dmg</td><td>(Str.: <font class='c_unimportant'>$equip[max_str]</font>)</td></tr></table>";
		}
		else if ($equip['equiptype'] == 1 || $equip['equiptype'] == 2)
		{
			$dmg = "RK: <font class='c_unimportant'>" . $equip['d_equip']['armor'] . '</font>';
			$critical = '<table class="c_caption" witdh=100% cellpadding=0 cellspacing=0><tr>';
			$critical .= "<td>Malus: <font class='c_unimportant'>$equip[malus]</font></td>";
			if ($equip['d_equip']['type'] == 2) $critical .= "<td width=50%>Max.Dex.: <font class='c_unimportant'>$equip[max_dex]</font></td>";
			$critical .= '</tr></table>';
			$attack = "Spellfailure: <font class='c_unimportant'>$equip[spell_failure]</font>";
		}
		else
		{
			$dmg = $critical = $attack = '';
		}
		echo mod_cols(array(
			'<font class="' . ($equip['noshield'] ? 'c_noshield' : 'c_unimportant') . '">' . adeptName($equip['name']) . '</font>' . ($equip['material'] != 0 ? (' (' . $MaterialShortOptions[$equip['material']] . ')') : ''),
			$dmg,
			$critical,
			$enhence,
			$attack,
			$money
		), array(5 => 'c_unimportant', -1 => 'c_caption'), true, false, array('', '', '', '', '', 'align=right'), true, $index == 0 ? ($index == count($char['equipment']) - 1 && !(count($equip['effects']) || $equip['text'] != '-') ? true : 1) : ($index == count($char['equipment']) - 1 && !(count($equip['effects']) || $equip['text'] != '-') ? -1 : 0));
		if (count($equip['effects']) || $equip['text'] != '-')
		{
			$tmptext = array();
			if (count($equip['effects']))
			{
				foreach ($equip['effects'] as $effect)
				{
					$tmptext[] = adeptName($effect['effect']) . ($effect['text'] == '' ? '' : (" ($effect[text])"));
				}
				$tmptext = array('<font class="c_caption">Effects:</font> ' . implode(', ', $tmptext));
			}
			if ($equip['text'] != '-')
			{
				$tmptext[] = $equip['text'];
			}
			echo "<tr><td class='c_left" . ($index == count($char['equipment']) - 1 ? 'c_bottom' : '') . "'>&nbsp;</td><td colspan=5 class='c_unimportant c_right" . ($index == count($char['equipment']) - 1 ? 'c_bottom' : '') . "'>" . implode(' - ', $tmptext) . '</td></tr>';
		}
	}
	else
	{
		$text = $equip['text'];
		if (count($equip['effects']))
		{
			if ($text == '-' && count($equip['effects'])) $text = '';
			$tmptext = array();
			foreach ($equip['effects'] as $effect)
			{
				$tmptext[] = adeptName($effect['effect']) . ($effect['text'] == '' ? '' : (" ($effect[text])"));
			}
			$text .= '<font class="c_caption">Effects:</font> ' . implode(', ', $tmptext);
		}

		echo mod_cols(
			array(
				adeptName($equip['name']),
				$text,
				$money
			), 'c_unimportant', true, array(0, 4, 0), array('', '', 'align=right'), true, $index == 0 ? 1 : ($index == count($char['equipment']) - 1 ? -1 : 0));
	}
}

echo '<tr>', mod_col('Money', "$char[money] ($char[money_left] Gold)", 0, false, true, 3), mod_col('Treasure', "$char[treasure] ($char[treasure_left] Gold)", 0, false, true, 3), mod_col("Sell Value", $char['sell_value'], true, false, true, 3), '</tr>';

echo '<tr><td class="c_top c_bottom c_left c_right c_caption" colspan=6>Spells / Powers</td></tr>';

foreach ($char['classes'] as $index => $class)
{
	$spelltype = (isset($class['powers']) ? 'powers' : (isset($class['spells_day']) ? 'spells_day' : false));
	if ($spelltype === false) continue;
	echo mod_cols(array(($class['class_id'] ? adeptName($class['class']) : adeptName($char['d_monster']['name'])) . " ($class[caster_level])", $class['d_class']['spellfailure'] ? 'Spell Failure:' : '', $class['d_class']['spellfailure'] ? $char['spell_failure'] : ''),
		array('c_unimportant', 'c_caption', 'c_important'), true, array(2, 0, 3), false, true, true);
	for ($i = 0;$i <= 10;$i++)
	{
		if ($i == 10) $i = -1;
	
		if (($i == -1 && !isset($class['spells'][-1])) || ($i != -1 && (!isset($class[$spelltype][$i]) || $class[$spelltype][$i] == 0))) if ($i == -1) break; else continue;

		if ($i != -1)
		{
			echo mod_cols(
				array(
					"Lvl: <font class='c_unimportant'>$i</font>",
					($spelltype == 'powers' ? 'Powers' : 'Spells per day') . ':',
					$class[$spelltype][$i],
					($showspellsknown = (isset($class['spells_known']) && $class['spells_known'][$i] > 0)) ? 'Spells known' : '',
					$showspellsknown ? $class['spells_known'][$i] : ''),
				array(-1 => 'c_caption', 2 => 'c_unimportant', 4 => 'c_unimportant'),
				true,
				array(4 => 2),
				array(0 => 'valign=top rowspan=' . ceil(($spelltype == 'powers' ? $spellcount = $class['powers'][$i] : $spellcount = ($class['spells_known'][$i] > 0 ? $class['spells_known'][$i] : $class['spells_day'][$i])) / 5 + 1)),
				-2, true
			);
		}
		else
		{
			if (($spellcount = count($class['spells'][-1])) == 0) break;
			echo '<tr><td valign=top class="c_caption" rowspan=', ceil($spellcount / 5), '>Domains:</td>';
			$noinittr = true;
		}
		for ($j = 0;$j < $spellcount;$j++)
		{
			if (!isset($noinittr) && $j % 5 == 0) echo '<tr>';
			if (isset($noinittr)) unset ($noinittr);

			echo '<td class="c_important c_left c_right' . ($j < 5 ? ' c_top' : '') . ($j >= $spellcount - $spellcount % 5 - ($spellcount % 5 == 0 ? 5 : 0) ? ' c_bottom' : '') . '">', adeptName($class['spells'][$i][$j]['name']), ' (', ($spelltype == 'powers' ? (substr($AttributeOptions[$class['spells'][$i][$j]['d_spell']['attribute']], 0, 3) . ' / ') : ''), $class['spells'][$i][$j]['dc'], ')</td>';
			if (($j + 1) % 5 == 0) echo '</tr>';
		}
		mod_fixpos($j % 5, 5, array('c_left c_right c_bottom' . ($spellcount <= 5 ? ' c_top' : '')));
		if ($i == -1) break;
	}
	unset($spelltype);
}

$texts = array('chartext' => 'Character Description', 'chartext_primary' => 'Primary Attack', 'chartext_secondary' => 'Secondary Attack', 'chartext_second' => 'Second Weapon');
foreach ($texts as $index => $text)
{
	if ($char[$index] == '') continue;
	echo "<tr><td colspan=6 class='c_caption c_left c_right c_top c_bottom'>$text</td></tr><tr><td colspan=6 class='c_important c_left c_right c_top c_bottom'><li class='c_caption'><font class='c_important'>" . str_replace(array("\r", "\n"), array('', '</font></li><li class="c_caption"><font class="c_important">'), $char[$index]). "</font></li></td></tr>";
}

echo '</table>';

//mprintr($char);

?>